<?php

class MonObjetDb extends db {
	public static function CreateTable () {
        static::Query ("CREATE TABLE IF NOT EXISTS matable (
        matable_id INTEGER PRIMARY KEY,
        matable_date TEXT NOT NULL,
        matable_texte TEXT NOT NULL
        )");
    }

    public static function LoadSample() {
        $allm = array(
            array('texte'=>"Symfony, l'un des framework les plus utilisé",'url'=>"http://symfony.com/"),
            array('texte'=>"L'un des premiers frameworks PHP, inspiré de RAIL",'url'=>"http://cakephp.org/"),
            array('texte'=>"Code Igniter, l'une des références",'url'=>"http://ellislab.com/codeigniter"),
            array('texte'=>"FuelPHP un framework qui monte en ce moment",'url'=>"http://www.fuelphp.com/")
        );
        foreach ($allm as $m) {
            $obj = new MonObjet();
            $obj->setTexte($m['texte']);
            self::Create($obj);
        }
    }

    public static function Create($obj) {
        static::Prepare("INSERT INTO matable (matable_date, matable_texte ) VALUES ( :date, :texte)");
        static::Execute(array(':date'=>$obj->getDate(),
                            ':texte'=>$obj->getTexte()
                            ));
    }

    public static function Read($id) {
        self::Prepare("SELECT * FROM matable WHERE matable_id = :id");
        $liste_messages = self::Execute(array(':id'=>(int)$id ));
        $row = $liste_messages[0];
        $obj = new MonObjet();
        $obj->setId($row['message_id']);
        $obj->setDate($row['message_date']);
        $obj->setTexte($row['message_texte']);
        return $obj;
    }

    public static function Update($obj) {
        static::Prepare("UPDATE matable SET matable_date = :date, matable_texte = :texte WHERE matable_id = :id");
        static::Execute(array(':date'=>$obj->getDate(),
                            ':texte'=>$obj->getTexte(),
                            ':id'=>$obj->getId()
                            ));
    }

    public static function Delete($id) {
        static::Prepare("DELETE FROM matable WHERE matable_id = :id");
        static::Execute(array(':id'=>$id ));
    }

    public static function ListObjet() {
      $objets = array();
      $liste_messages = self::Query("SELECT * FROM matable ORDER BY matable_date DESC");
      foreach($liste_messages as $row) {
          $obj = new MonObjet();
          $obj->setId($row['matable_id']);
          $obj->setDate($row['matable_date']);
          $obj->setTexte($row['matable_texte']);
          $objets[] = $obj;
      }
      return $objets;
    }

}
